# -*- coding:Utf-8 -*-
from simplemenu_line import SimpleLine
from simplemenu_base import SimpleBase
import psyco, es, sys, popuplib2, simplemenu_tool
psyco.full()

class SimpleMenu(SimpleBase, SimpleLine):
#class SimpleMenu(object):
    def __init__(self, name, defaultlang, separators, reversenav):
        SimpleBase.__init__(self, reversenav, defaultlang, separators)
        self.name = name
        self.type = "menu"
        self.showpage = "auto"
        self.menuselect = None
        self.menuselectic = None
        self.menuselectnc = None

        self.p_pages = []
        self.p_lines = [""]
        self.p_totalpage = 0
        self.p_returnkey = False
        self.p_multilang = False
        self.p_constructed = False
        self.p_menulang = {
            "_smlib_page" : {"en" : "     $page/$total", "fr" : "     $page/$total"},
            "_smlib_next" : {"en" : "Next page", "fr" : "Page suivante"},
            "_smlib_back" : {"en" : "Previous page", "fr" : "Page précédente"},
            "_smlib_exit" : {"en" : "Cancel", "fr" : "Fermer le menu"}}

    def __del__(self):
        for popup in self.p_pages: del popup

    def p_select(self, args):
        userid, index, popupid, page = args["userid"], args["choice"], args["popup"], args["page"]
        values, navfunc, lastpage = args["values"], args["navfunc"], args["previous"]

        if values.has_key(index):
            choice, value, submenu, line = values[index]
            userargs = {
                "userid" : userid,
                "index" : index,
                "choice" : choice,
                "modifieditem" : line["modifieditem"],
                "value" : value,
                "page" : page,
                "menuid" : self.name,
                "menu" : self}

            # thx GODJonez !
            try: self.menuselect(userargs)
            except Exception:
                sys.excepthook(*sys.exc_info())
                sys.exc_clear()
                select = None

        elif navfunc.has_key(index):
            newpage = navfunc[index]
            userargs = {
                "userid" : userid,
                "index" : index,
                "menuid" : self.name,
                "page" : page,
                "menu" : self}

            try: self.menuselectnc(userargs)
            except Exception:
                sys.excepthook(*sys.exc_info())
                sys.exc_clear()

            if newpage:
                try: self.p_pages[page + newpage - 1].send(userid)
                except IndexError: pass

        else:
            userargs = {
                "userid" : userid,
                "index" : index,
                "menuid" : self.name,
                "page" : page,
                "menu" : self}

            try: self.menuselectic(userargs)
            except Exception:
                sys.excepthook(*sys.exc_info())
                sys.exc_clear()

    def construct(self):
        indexlist = 1
        self.p_totalitem = len(self.p_lines) - 1
        self.p_totalpage = simplemenu_tool.getTotalPage(self.p_totalitem)

        if self.showpage == "auto": showpage = True if self.p_totalitem > 8 else False
        else: showpage = self.showpage
        if len(self.p_pages) > self.p_totalpage:
            for popup in self.p_pages[self.p_totalpage:]: del popup

        for currentpage in xrange(1, self.p_totalpage + 1):
            popup = popuplib2.Popup()
            self.p_pages.append(popup)
            value = popup.menuselect_args["value"] = {}
            navfunc = popup.menuselect_args["navfunc"] = {}

            for sep in self.b_separators[0]: popup.append(sep)
            title = self.p_lines[0]
            if isinstance(title, SimpleLine): title = title["modifieditem"]

            if title:
                if showpage:
                    title += self.p_menulang["_smlib_page"][self.b_defaultlang]
                    title = title.replace("$page", str(currentpage)).replace("$total", str(self.p_totalpage))
                popup.append(title)
            for sep in self.b_separators[1]: popup.append(sep)

            for indexitem in xrange(1, simplemenu_tool.getItemsPage(currentpage, self.p_totalpage, self.p_totalitem) + 1):
                line = self.p_lines[indexlist]
                line.l_page = currentpage
                line.l_index = indexitem
                line.l_listid = indexlist
                line.l_popupid = popup

                popup.append(line["formatline"])
                value[indexitem] = (line.l_item, line.l_value, line.l_submenu, line)
                indexlist += 1
            for sep in self.b_separators[2]: popup.append(sep)


            cmppage = cmp(self.p_totalpage, currentpage)
            if self.b_reversenav:
                if cmppage:
                    navfunc[8] = 1
                    popup.append("8. " + self.p_menulang["_smlib_next"][self.b_defaultlang])

                if currentpage == 1:
                    if self.p_returnkey:
                        navfunc[9] = 0
                        popup.append("9. " + self.p_menulang["_smlib_back"][self.b_defaultlang])

                else:
                    navfunc[9] = -1
                    popup.append("9. " + self.p_menulang["_smlib_back"][self.b_defaultlang])

            else:
                if currentpage == 1:
                    if self.p_returnkey:
                        navfunc[8] = 0
                        popup.append("8. " + self.p_menulang["_smlib_back"][self.b_defaultlang])

                elif cmppage > -1:
                    navfunc[8] = - 1
                    popup.append("8. " + self.p_menulang["_smlib_back"][self.b_defaultlang])

                if cmppage:
                    navfunc[9] = 1
                    popup.append("9. " + self.p_menulang["_smlib_next"][self.b_defaultlang])
            navfunc[10] = 0
            popup.append("0. " + self.p_menulang["_smlib_exit"][self.b_defaultlang])

            popup.menuselect_args = {"page" : currentpage, "values" : value, "navfunc" : navfunc}
            popup.menuselect = self.p_select

            for sep in self.b_separators[3]: popup.append(sep)
        self.i_construct = True

    def title(self, title, options = {}, showpage = "auto"):
        self.showpage = bool(showpage) if showpage <> "auto" else showpage
        if not self.p_constructed:
            self.p_lines.insert(0, SimpleLine(title, options = options, underline = False))
            del self.p_lines[1]

    def additem(self, item, value = "", options = {}, prefix = "", underline = True, submenu = ""):
        if not self.p_constructed:
            self.p_lines.append(SimpleLine(item, value, options, prefix, underline, submenu))

    def send(self, users, page = 1):
        if not self.p_constructed: self.construct()
        try: page = int(page)
        except ValueError:
            es.dbgmsb(1, 'simplemenulib: wrong value for parameter "page"')
            page = 1

        try: self.p_pages[page - 1].send(users)
        except IndexError:
            es.dbgmsb(1, 'simplemenulib: cannot send page "%s" of menu "%s"' % (page, self.name))
            try: self.p_pages[0].send(users)
            except IndexError: es.dbgmsb(0, 'simplemenulib: cannot send menu "%s"' % self.name)
