# -*- coding:Utf-8 -*-
import es, psyco, random, gamethread, dm_player
psyco.full()


# ESP to ESS method
ess = es.server.insertcmd

############################
# PLAYER
def respawnPlayer(player):
    if isinstance(player, int): player = dm_player.player(player)
    es.setplayerprop(player.userid, "CCSPlayer.m_iPlayerState", 0)
    es.setplayerprop(player.userid, "CCSPlayer.baseclass.m_lifeState", 512)
    ess("es_xspawnplayer " + player.struserid)

def giveEntityToPlayer(userid, classname):
    # give entity to the player
    ess("es_xgive %s %s" % (userid, classname))

def setPositionOfPlayer(userid, ox, oy, oz, ax, ay, az):
    ess("es_xsetpos %s %s %s %s;" % (userid, ox, oy, oz))
    ess("es_xsetang %s %s %s %s" % (userid, ax, ay, az))

def stripWeaponsOfPlayer(userid):
    ess("es_xcreateentity player_weaponstrip")
    ess("es_xfire %s player_weaponstrip strip" % userid)
    ess("es_xfire %s player_weaponstrip kill" % userid)

def removePlayerRagDoll(player, dissolve = False, delay = True):
    def removeRagDollDelayed():
        # dissolve ragdoll by its targetname
        if dissolve: dissolveEntity(player.entitiesRagDoll)
        # or remove ragdoll by its targetname
        else:
            userid = es.getuserid()
            if userid: ess("es_fire %s %s kill" % (userid, player.entitiesRagDoll))

    # if "player" parameter is an userid
    if isinstance(player, int): player = dm_player.player(player)
    # find player's ragdoll
    for index in es.createentityindexlist("cs_ragdoll"):
        if es.getindexprop(index, "CCSRagdoll.m_hPlayer") == player.player.handle:
            es.setentityname(index, player.entitiesRagDoll)
            break
    # remove the ragdoll with a delay
    if delay: gamethread.delayedname(.7, player.threadRagDoll, removeRagDollDelayed)
    else: removeRagDollDelayed()

############################
# ENTITY
def removeEntity(targetname, userid = None, dissolve = None):
    userid = es.getuserid() if userid is None else userid
    if userid:
        if isinstance(targetname, int):
            es.setentityname(targetname, "_dm_python_entities_to_kill")
            targetname = "_dm_python_entities_to_kill"
        if not dissolve: ess("es_xfire %s %s kill" % (userid, targetname))
        else: dissolveEntity(targetname, userid)

def dissolveEntity(target, userid = None):
    userid = es.getuserid() if userid is None else userid
    if userid:
        # create an "env_entity_dissolver" entity and set key values and target
        ess(
            "es_xcreateentity env_entity_dissolver _dm_python_entity_dissolver;" +
            "es_entitysetvalue server_var(eventscripts_lastgive) dissolvetype %s;" % random.randint(0,3) +
            "es_entitysetvalue server_var(eventscripts_lastgive) target %s;" % target +
            "es_entitysetvalue server_var(eventscripts_lastgive) magnitude 100")
        # dissolve target and kill "env_entity_dissolver" entity
        ess("es_xfire %s _dm_python_entity_dissolver dissolve" % userid)
        ess("es_xfire %s _dm_python_entity_dissolver kill" % userid)

def removeObjectivesFromTheMap():
    userid = es.getuserid()
    if userid:
        # remove objectives (hostages, hostage zone, bomb zone, buy zone)
        ess("es_xfire %s func_hostage_* kill" % userid)
        ess("es_xfire %s func_bomb_* kill" % userid)
        ess("es_xfire %s func_buyzone_* kill" % userid)
        ess("es_xfire %s hostage_entity kill" % userid)

def removeWeaponsAndItemsOnTheGround(dissolve):
    userid = es.getuserid()
    if userid:
        entities = es.createentityindexlist()
        # for each entity
        for index in entities:
            classname = es.entitygetvalue(index, "classname")
            # if entity is a weapon or an item
            if classname.startswith("weapon_") or classname.startswith("item_"):
                # with any owner
                if es.getindexprop(index, "CBaseEntity.m_hOwnerEntity") == -1:
                    # set targetname for prepare to kill the entity
                    es.setentityname(index, "_dm_python_entities_to_kill")

        # dissolve all entity registered by their targetname
        if dissolve: dissolveEntity("_dm_python_entities_to_kill")
        # or kill all entity registered by their targetname
        else: ess("es_xfire %s _dm_python_entities_to_kill kill" % userid)
